void makeBalls(int _number)
{
  myBall = new Ball[_number];
  for (int i = 0; i < _number; i++) {

    if (i < _number/6)
    {

      myBall[i] = new Ball(random(-.1, .1));
    } 
    else
    {
      myBall[i] = new Ball(random(-.01, .01));
    }
  }
}





void drawBalls() {
  for (int i = 0; i < ballAmount; i++) {
    myBall[i].step();

    for (int j = 0; j < i; j++) {
      //for (int n=0; n<pnts.length; n++) {
      if (i != j) {
        float distBalls = dist(myBall[i].x, myBall[i].y, myBall[j].x, myBall[j].y);

        if (distBalls <= bDistance && distBalls >= 3) {
          //println(10/distBalls);
          lineWeight = 10/distBalls;

          stroke(0, map(distBalls, 3, bDistance, 40, 0));
          strokeWeight(lineWeight);

          //line(myBall[i].x, myBall[i].y, pnts[n].x, pnts[n].y);
          line(myBall[i].x, myBall[i].y, myBall[j].x, myBall[j].y);
        }
        //}
      }
    }

    /*
    for (int k = 0; k < ballAmount; k++) {
     fill(255, 0, 0);
     myBall[k].drawBall(); //BALL IS NOT DRAWN
     }
     */
  }
}

void drawFontBall()
{
  for (int l=0; l < grp.length;l++) {
    noFill();
    pushMatrix();
    translate(letterX, letterY);

    //if (mousePressed) danceFactor = map(mouseX, 0,width, 1,3); //1,3
    //else
    danceFactor = 4;
    // are there points to draw?
    //if (grp.getWidth() > 0) {
    // let the points dance

    letterY = l* lineSpacing/3*2.5 + 300;
    textW += spacing + 100;
    if (l >1) textW = 0 ;
    if (l >2) textW = 1000 ;
    letterX = textW;
    textW = grp[l].getWidth();
    pnts = grp[l].getPoints(); 

    //textW = letterX = 20; 
    for (int i = 0; i < pnts.length; i++ ) {
      pnts[i].x += random(-.3, .3)*danceFactor;
      pnts[i].y += random(-.5, .5)*danceFactor;
    }

    //  ------ lines: connected rounded  ------

    stroke(0, 50);
    strokeWeight(.5);
    //stroke(200,0,0);
    beginShape();
    // start controlpoint
    // curveVertex(pnts[pnts.length-1].x, pnts[pnts.length-1].y);
    // only these points are drawn
    for (int n=0; n<pnts.length; n++) {
      curveVertex(pnts[n].x, pnts[n].y);
    }
    // curveVertex(pnts[0].x, pnts[0].y);
    // end controlpoint
    //curveVertex(pnts[1].x, pnts[1].y);
    endShape();

    beginShape();
    // start controlpoint
    vertex(pnts[pnts.length-1].x, pnts[pnts.length-1].y);
    // only these points are drawn
    for (int n=0; n<pnts.length; n++) 
    {
      vertex(pnts[n].x, pnts[n].y);
    }
    // curveVertex(pnts[0].x, pnts[0].y);
    // end controlpoint
    //curveVertex(pnts[1].x, pnts[1].y);
    endShape();

    //  ------ lines: connected straight  ------

    beginShape();
    for (int i=0; i<pnts.length; i++) {
      for (int j = 0; j < ballAmount; j++) {
        float distFont = dist(pnts[i].x, pnts[i].y, myBall[j].x, myBall[j].y);
        if (distFont <= bDistance*2 && distFont >= 3) {
          pushStyle();
          stroke(0, map(distFont, 3, bDistance, 50, 0));
          lineWeight2 = 10/distFont;

          strokeWeight(lineWeight2);
          line(pnts[i].x, pnts[i].y, myBall[j].x, myBall[j].y);
          popStyle();
        }
      }
    }
    //vertex(pnts[0].x, pnts[0].y);
    endShape();

    // }

    popMatrix();
  }
}
void drawUPoints()
{
  getUserPixel();

  Iterator i = uBalls.entrySet().iterator();
  ArrayList removeB = new ArrayList();
  while (i.hasNext ())
  {
    Map.Entry me = (Map.Entry)i.next();

    Ball tBall = (Ball) me.getValue();
    tBall.update();
    for (int j = 0; j < ballAmount; j++) {



      float distUBalls = dist(tBall.x, tBall.y, myBall[j].x, myBall[j].y);
      if (distUBalls <= bDistance*2 && distUBalls >= 3) {
        pushStyle();
        stroke(0, map(distUBalls, 3, bDistance, 50, 10));
        lineWeight2 = 10/distUBalls;

        strokeWeight(lineWeight2);
        line(tBall.x, tBall.y, myBall[j].x, myBall[j].y);
        popStyle();
        if (tBall.ballTime < millis()-random(500, 700))
        {      
          //println("remove");
          removeB.add(me.getKey());
        }
      }
    }
  }
  for (int ri= 0; ri < removeB.size(); ri++)
  {

    uBalls.remove((Integer) removeB.get(ri));
  }
}

