PVector[] kinectUserList(IntVector _userL)

{
  //println("inttest = "+  int(_userL.size()));
  PVector kUserL[] = new PVector[int(_userL.size())];

  IntVector userList = _userL;

  for (int i = 0; i < userList.size(); i++)
  {
    int userId = userList.get(i);
    PVector _kPosition = new PVector();
    kinect.getCoM(userId, _kPosition);
    kinect.convertRealWorldToProjective(_kPosition, _kPosition);
    _kPosition.set(map(_kPosition.x, 0, 640, 0, width), _kPosition.y, _kPosition.z);
    _kPosition.set(_kPosition.x, map(_kPosition.y, 0, 480, 0, height), _kPosition.z);

    kUserL[i] = new PVector(_kPosition.x, _kPosition.y, _kPosition.z);
  }
  return kUserL;
}


void kinect(PVector[] _userL)
{
  PVector[] userL = new PVector[_userL.length];
  userL = _userL;

  if ( userL != null)
  {
    for (int i = 0; i < userL.length; i++)
    {

      PVector positionU = userL[i];

      float posPX, posPY, posPZ; 
      String posX = str(positionU.x);
      String posY = str(positionU.y);
      String posZ = str(positionU.z);
      //println(posX + ", " + posY + ", " + posZ);
      pushMatrix();
      //translate(0, 0, map(position.z, 500, 2000, 1000, 0));
      text(posZ, positionU.x+25+5, positionU.y-6);
      pushStyle();
      fill(255, 0, 0);
      ellipse(positionU.x, positionU.y, 20, 20);
      popStyle();
      popMatrix();
    }
  }
}

void getUserPixel() {
  int sceneWidth = kinect.sceneWidth();
  int sceneHeight = kinect.sceneHeight();
  int wScale = width /sceneWidth;
  int hScale = height / sceneHeight;

  for (int x = 0; x < sceneWidth; x+=userResolution)
  {

    for ( int y = 0; y < sceneHeight; y+=userResolution)
    {
      int index = x + y * sceneWidth;
      if (sceneMap[index] > 0)
      {

        if ( uBalls.get(index) == null)
        {
          uBalls.put((Integer) index, new Ball(x*wScale+random(-userResolution, userResolution), y*hScale+random(-userResolution, userResolution), 0, sceneMap[index], index));
        }
        else {
          Ball tBall = (Ball) uBalls.get(index);
          tBall.ballTime = millis();
        }
      }
    }
  }
}

